#!/usr/bin/env python3
import RPi.GPIO as GPIO
from flask import Flask, jsonify, render_template
import random
import time
import threading
import socketserver
import logging
import sys
import os
import cgi
import json
import serial

fileObject = open("config.json", "r")
jsonContent = fileObject.read()
config = json.loads(jsonContent)
#print(config)
com="/dev/ttyUSB0"
baud=9600
GPIO.setwarnings(False)
os.system('pkill -9 httpd')
GPIO.setmode(GPIO.BCM)
pinList = [4,17,27,22,5,6,13,19,26,21,20,16,12,25,24,23]
SleepTimeL=10
app = Flask(__name__)
demomode=0
os.system('./relay.py power 0')

# Lecture Data Arduino
def ReadData():

    if (os.path.exists(com)):
 #      try:
         global ser
         data="0,0,0,0,0,0,0,0,0"
         ser = serial.Serial(com, baud, timeout=10)
            # open the serial port
         if ser.isOpen():
            print(ser.name + ' is opening...')
            boucle1=True
            cmd = "m"
            ser.write(cmd.encode('UTF-8')+ b"\n")
            #Connextion
            time.sleep(0.5)
            while boucle1:
                data = ser.read(48)
                print(data)
                if len(data) > 45:
                   #ser.write(cmd.encode('UTF-8')+ b"\n")
                   #print ('Got:', data)
                   break
                   boucle1=False
         #print ("La suite")
         data=str(data)
         data=data.replace("\\n","")
         data=data.replace("b'","")
         data=data.replace("'","")
         print (data)
         data=data.split(",")
         print (data)
         #Dog sensor
         if data[6]=="-127.00":
            data[6]="*"
         if data[7]=="-127.00":
            data[7]="*"
         if data[8]=="-127.00":
            data[8]="*"


         return data
#       except:
#         print("Pas de connexion possible avec ce port com!")

# Générateur aléatoire pour simuler les données de température en temps réel
def t_generator():
    while True:
        #Télémétry
        if demomode==0:
           # ['0.00', '0.00', '-5.83', '4.73', '4.87', '4.32', '-127.00', '-127.00', '-127.00'] 
           data=ReadData()
           t_data = {
              'i1': data[0],
              'i2': data[1],
              'i3': data[2],
              'v1': data[3],
              'v2': data[4],
              'v3': data[5],
              't1': data[6],
              't2': data[7],
              't3': data[8],
              'timestamp': time.time()
           }
        else:
           t_data = {
              'i1': round(random.uniform(7, 15), 2),
              'i2': round(random.uniform(2, 3), 2),
              'i3': round(random.uniform(2, 3), 2),
              'v1': round(random.uniform(25, 28), 2),
              'v2': round(random.uniform(11, 13), 2),
              'v3': round(random.uniform(4, 6), 2),
              't1': round(random.uniform(20, 30), 2),
              't2': round(random.uniform(20, 30), 2),
              't3': round(random.uniform(20, 30), 2),
              'timestamp': time.time()
           }
        yield t_data

        time.sleep(1)  # Attendre 1 seconde avant de générer la prochaine donnée de température

def gen_template ():
    fileObject = open("config.json", "r")
    jsonContent = fileObject.read()
    config = json.loads(jsonContent)
    #print(config)

    fichier = open("index.template.html","r")
    file=fichier.read()
    #replace config in index.html
    file = file.replace("DESIGN0",config['com1'])
    file = file.replace("DESIGN1",config['com2'])
    file = file.replace("DESIGN2",config['com3'])
    file = file.replace("DESIGN3",config['com4'])
    file = file.replace("DESIGN4",config['com5'])
    file = file.replace("DESIGN5",config['com6'])
    file = file.replace("DESIGN6",config['com7'])
    file = file.replace("DESIGN7",config['com8'])
    file = file.replace("DESIGN8",config['com9'])
    file = file.replace("DESIGN9",config['com10'])
    file = file.replace("DESIGNA",config['com11'])
    file = file.replace("DESIGNB",config['com12'])
    file = file.replace("DESIGNC",config['com13'])
    file = file.replace("DESIGND",config['com14'])
    file = file.replace("DESIGNE",config['com15'])
    file = file.replace("DESIGNF",config['com16'])
    file = file.replace("URL_HTTP",config['url'])
    file = file.replace("PORT_HTTP",str(config['port']))

    GPIO.setup(pinList[0], GPIO.OUT)
    status0=int(GPIO.input(pinList[0]))
    ##print ('Relay0 = '+str(status0))
    if status0 == 0:
       file = file.replace("CHECKED0", "checked")

    GPIO.setup(pinList[1], GPIO.OUT)
    status1=int(GPIO.input(pinList[1]))
    ##print ('Relay1 = '+str(status1))
    if status1 == 0:
       file = file.replace("CHECKED1", "checked")

    GPIO.setup(pinList[2], GPIO.OUT)
    status2=int(GPIO.input(pinList[2]))
    ##print ('Relay2 = '+str(status2))
    if status2 == 0:
       file = file.replace("CHECKED2", "checked")

    GPIO.setup(pinList[3], GPIO.OUT)
    status3=int(GPIO.input(pinList[3]))
    ##print ('Relay3 = '+str(status3))
    if status3 == 0:
       file = file.replace("CHECKED3", "checked")

    GPIO.setup(pinList[4], GPIO.OUT)
    status4=int(GPIO.input(pinList[4]))
    ##print ('Relay4 = '+str(status4))
    if status4 == 0:
       file = file.replace("CHECKED4", "checked")

    GPIO.setup(pinList[5], GPIO.OUT)
    status5=int(GPIO.input(pinList[5]))
    ##print ('Relay5 = '+str(status5))
    if status5 == 0:
       file = file.replace("CHECKED5", "checked")

    GPIO.setup(pinList[6], GPIO.OUT)
    status6=int(GPIO.input(pinList[6]))
    ##print ('Relay6 = '+str(status6))
    if status6 == 0:
       file = file.replace("CHECKED6", "checked")

    GPIO.setup(pinList[7], GPIO.OUT)
    status7=int(GPIO.input(pinList[7]))
    #print ('Relay7 = '+str(status7))
    if status7 == 0:
       file = file.replace("CHECKED7", "checked")

    GPIO.setup(pinList[8], GPIO.OUT)
    status8=int(GPIO.input(pinList[8]))
    #print ('Relay8 = '+str(status8))
    if status8 == 0:
       file = file.replace("CHECKED8", "checked")

    GPIO.setup(pinList[9], GPIO.OUT)
    status9=int(GPIO.input(pinList[9]))
    #print ('Relay9 = '+str(status9))
    if status9 == 0:
       file = file.replace("CHECKED9", "checked")

    GPIO.setup(pinList[10], GPIO.OUT)
    status10=int(GPIO.input(pinList[10]))
    #print ('Relay10 = '+str(status10))
    if status10 == 0:
       file = file.replace("CHECKEDA", "checked")

    GPIO.setup(pinList[11], GPIO.OUT)
    status11=int(GPIO.input(pinList[11]))
    #print ('Relay11 = '+str(status11))
    if status11 == 0:
       file = file.replace("CHECKEDB", "checked")

    GPIO.setup(pinList[12], GPIO.OUT)
    status12=int(GPIO.input(pinList[12]))
    #print ('Relay12 = '+str(status12))
    if status12 == 0:
       file = file.replace("CHECKEDC", "checked")

    GPIO.setup(pinList[13], GPIO.OUT)
    status13=int(GPIO.input(pinList[13]))
    #print ('Relay13 = '+str(status13))
    if status13 == 0:
       file = file.replace("CHECKEDD", "checked")

    GPIO.setup(pinList[14], GPIO.OUT)
    status14=int(GPIO.input(pinList[14]))
    #print ('Relay14 = '+str(status14))
    if status14 == 0:
       file = file.replace("CHECKEDE", "checked")

    GPIO.setup(pinList[15], GPIO.OUT)
    status15=int(GPIO.input(pinList[15]))
    #print ('Relay15 = '+str(status15))
    if status15 == 0:
       file = file.replace("CHECKEDF", "checked")


    fichier= open("templates/index.html","w")
    fichier.write(file)
    fichier.close()


# Route pour récupérer la température en temps réel
@app.route('/t', methods=['GET'])
def get_t():

    return jsonify(next(t_generator()))

# Route pour afficher la page HTML avec rafraîchissement automatique des données
@app.route('/')
def index():
    gen_template()
    return render_template("index.html")

@app.route('/R0')
def R0():
    print ('R0 run')
    GPIO.setup(pinList[0], GPIO.OUT)
    status0=int(GPIO.input(pinList[0]))
    if status0 == 1:
       os.system('./relay.py open 0')
    else:
       os.system('./relay.py close 0')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 0')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R0O')
def R0O():
    print ('R0O run0')
    GPIO.setup(pinList[0], GPIO.OUT)
    status0=int(GPIO.input(pinList[0]))
    if status0 == 1:
       os.system('./relay.py open 0')
    else:
       os.system('./relay.py close 0')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R1')
def R1():
    print ('R1 run')
    GPIO.setup(pinList[1], GPIO.OUT)
    status1=int(GPIO.input(pinList[1]))
    if status1 == 1:
       os.system('./relay.py open 1')
    else:
       os.system('./relay.py close 1')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 1')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R1O')
def R1O():
    print ('R1O run0')
    GPIO.setup(pinList[1], GPIO.OUT)
    status1=int(GPIO.input(pinList[1]))
    if status1 == 1:
       os.system('./relay.py open 1')
    else:
       os.system('./relay.py close 1')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R2')
def R2():
    print ('R2 run')
    GPIO.setup(pinList[2], GPIO.OUT)
    status2=int(GPIO.input(pinList[2]))
    if status2 == 1:
       os.system('./relay.py open 2')
    else:
       os.system('./relay.py close 2')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 2')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R2O')
def R2O():
    print ('R2O run0')
    GPIO.setup(pinList[2], GPIO.OUT)
    status2=int(GPIO.input(pinList[2]))
    if status2 == 1:
       os.system('./relay.py open 2')
    else:
       os.system('./relay.py close 2')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R3')
def R3():
    print ('R3 run')
    GPIO.setup(pinList[3], GPIO.OUT)
    status3=int(GPIO.input(pinList[3]))
    if status3 == 1:
       os.system('./relay.py open 3')
    else:
       os.system('./relay.py close 3')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 3')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R3O')
def R3O():
    print ('R3O run0')
    GPIO.setup(pinList[3], GPIO.OUT)
    status3=int(GPIO.input(pinList[3]))
    if status3 == 1:
       os.system('./relay.py open 3')
    else:
       os.system('./relay.py close 3')
    gen_template()
    get_t()
    return render_template("index.html")
@app.route('/R4')
def R4():
    print ('R4 run')
    GPIO.setup(pinList[4], GPIO.OUT)
    status4=int(GPIO.input(pinList[4]))
    if status4 == 1:
       os.system('./relay.py open 4')
    else:
       os.system('./relay.py close 4')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 4')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R4O')
def R4O():
    print ('R4O run0')
    GPIO.setup(pinList[4], GPIO.OUT)
    status4=int(GPIO.input(pinList[4]))
    if status4 == 1:
       os.system('./relay.py open 4')
    else:
       os.system('./relay.py close 4')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R5')
def R5():
    print ('R5 run')
    GPIO.setup(pinList[5], GPIO.OUT)
    status5=int(GPIO.input(pinList[5]))
    if status5 == 1:
       os.system('./relay.py open 5')
    else:
       os.system('./relay.py close 5')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 5')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R5O')
def R5O():
    print ('R5O run0')
    GPIO.setup(pinList[5], GPIO.OUT)
    status5=int(GPIO.input(pinList[5]))
    if status5 == 1:
       os.system('./relay.py open 5')
    else:
       os.system('./relay.py close 5')
    gen_template()
    get_t()
    return render_template("index.html")
@app.route('/R6')
def R6():
    print ('R6 run')
    GPIO.setup(pinList[6], GPIO.OUT)
    status6=int(GPIO.input(pinList[6]))
    if status6 == 1:
       os.system('./relay.py open 6')
    else:
       os.system('./relay.py close 6')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 6')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R6O')
def R6O():
    print ('R6O run0')
    GPIO.setup(pinList[6], GPIO.OUT)
    status6=int(GPIO.input(pinList[6]))
    if status6 == 1:
       os.system('./relay.py open 6')
    else:
       os.system('./relay.py close 6')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R7')
def R7():
    print ('R7 run')
    GPIO.setup(pinList[7], GPIO.OUT)
    status7=int(GPIO.input(pinList[7]))
    if status7 == 1:
       os.system('./relay.py open 7')
    else:
       os.system('./relay.py close 7')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 7')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R7O')
def R7O():
    print ('R7O run0')
    GPIO.setup(pinList[7], GPIO.OUT)
    status7=int(GPIO.input(pinList[7]))
    if status7 == 1:
       os.system('./relay.py open 7')
    else:
       os.system('./relay.py close 7')
    gen_template()
    get_t()
    return render_template("index.html")
@app.route('/R8')
def R8():
    print ('R8 run')
    GPIO.setup(pinList[8], GPIO.OUT)
    status8=int(GPIO.input(pinList[8]))
    if status8 == 1:
       os.system('./relay.py open 8')
    else:
       os.system('./relay.py close 8')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 8')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R8O')
def R8O():
    print ('R8O run0')
    GPIO.setup(pinList[8], GPIO.OUT)
    status8=int(GPIO.input(pinList[8]))
    if status8 == 1:
       os.system('./relay.py open 8')
    else:
       os.system('./relay.py close 8')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R9')
def R9():
    print ('R9 run')
    GPIO.setup(pinList[9], GPIO.OUT)
    status9=int(GPIO.input(pinList[9]))
    if status9 == 1:
       os.system('./relay.py open 9')
    else:
       os.system('./relay.py close 9')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 9')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/R9O')
def R9O():
    print ('R9O run0')
    GPIO.setup(pinList[1], GPIO.OUT)
    status9=int(GPIO.input(pinList[9]))
    if status9 == 1:
       os.system('./relay.py open 9')
    else:
       os.system('./relay.py close 9')
    gen_template()
    get_t()
    return render_template("index.html")
@app.route('/RA')
def RA():
    print ('RA0 run')
    GPIO.setup(pinList[10], GPIO.OUT)
    status10=int(GPIO.input(pinList[10]))
    if status10 == 1:
       os.system('./relay.py open 10')
    else:
       os.system('./relay.py close 10')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 10')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/RAO')
def RAO():
    print ('RAO run0')
    GPIO.setup(pinList[10], GPIO.OUT)
    status10=int(GPIO.input(pinList[10]))
    if status10 == 1:
       os.system('./relay.py open 10')
    else:
       os.system('./relay.py close 10')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/RB')
def RB():
    print ('RB run')
    GPIO.setup(pinList[11], GPIO.OUT)
    status11=int(GPIO.input(pinList[11]))
    if status11 == 1:
       os.system('./relay.py open 11')
    else:
       os.system('./relay.py close 11')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 11')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/RBO')
def RBO():
    print ('RBO run0')
    GPIO.setup(pinList[11], GPIO.OUT)
    status11=int(GPIO.input(pinList[11]))
    if status11 == 1:
       os.system('./relay.py open 11')
    else:
       os.system('./relay.py close 11')
    gen_template()
    get_t()
    return render_template("index.html")
@app.route('/RC')
def RC():
    print ('RC run')
    GPIO.setup(pinList[12], GPIO.OUT)
    status12=int(GPIO.input(pinList[12]))
    if status12 == 1:
       os.system('./relay.py open 12')
    else:
       os.system('./relay.py close 12')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 12')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/RCO')
def RCO():
    print ('RCO run0')
    GPIO.setup(pinList[12], GPIO.OUT)
    status12=int(GPIO.input(pinList[12]))
    if status12 == 1:
       os.system('./relay.py open 12')
    else:
       os.system('./relay.py close 12')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/RD')
def RD():
    print ('RD run')
    GPIO.setup(pinList[13], GPIO.OUT)
    status13=int(GPIO.input(pinList[13]))
    if status13 == 1:
       os.system('./relay.py open 13')
    else:
       os.system('./relay.py close 13')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 13')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/RDO')
def RDO():
    print ('RDO run0')
    GPIO.setup(pinList[13], GPIO.OUT)
    status13=int(GPIO.input(pinList[13]))
    if status13 == 1:
       os.system('./relay.py open 13')
    else:
       os.system('./relay.py close 13')
    gen_template()
    get_t()
    return render_template("index.html")
@app.route('/RE')
def RE():
    #print ('Re run')
    GPIO.setup(pinList[14], GPIO.OUT)
    status14=int(GPIO.input(pinList[14]))
    if status14 == 1:
       os.system('./relay.py open 14')
    else:
       os.system('./relay.py close 14')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 14')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/REO')
def REO():
    #print ('ReO run0')
    GPIO.setup(pinList[14], GPIO.OUT)
    status14=int(GPIO.input(pinList[14]))
    if status14 == 1:
       os.system('./relay.py open 14')
    else:
       os.system('./relay.py close 14')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/RF')
def RF():
    print ('RF run')
    GPIO.setup(pinList[15], GPIO.OUT)
    status15=int(GPIO.input(pinList[15]))
    if status15 == 1:
       os.system('./relay.py open 15')
    else:
       os.system('./relay.py close 15')
       time.sleep(int(SleepTimeL));
       os.system('./relay.py open 15')
    gen_template()
    get_t()
    return render_template("index.html")

@app.route('/RFO')
def RFO():
    print ('RFO run0')
    GPIO.setup(pinList[15], GPIO.OUT)
    status15=int(GPIO.input(pinList[15]))
    if status15 == 1:
       os.system('./relay.py open 15')
    else:
       os.system('./relay.py close 15')
    gen_template()
    get_t()
    return render_template("index.html")

if __name__ == '__main__':
    app.config['TEMPLATES_AUTO_RELOAD'] = True
    threading.Thread(target=app.run, kwargs={'host': config['url'], 'port': config['port']}).start()
